"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var addon_actions_1 = require("@storybook/addon-actions");
var addon_knobs_1 = require("@storybook/addon-knobs");
var react_1 = require("@storybook/react");
var React = tslib_1.__importStar(require("react"));
var __1 = require("../");
var Empty = function (_a) {
    var intersecting = _a.intersecting, height = _a.height;
    return (React.createElement("div", { style: { height: height, background: intersecting ? 'lightgray' : 'whitesmoke' } }));
};
Empty.defaultProps = {
    height: '120vh',
};
var Text = function (_a) {
    var intersecting = _a.intersecting;
    return (React.createElement("h1", { style: { padding: '5rem 0', textAlign: 'center' } }, intersecting ? 'intersecting!!' : 'hiding'));
};
var Overview = function () {
    var target = React.useRef(null);
    var intersecting = __1.useIntersection(target, {
        rootMargin: addon_knobs_1.text('rootMargin', '0px'),
        threshold: addon_knobs_1.number('threshold', 0, { range: true, min: 0, max: 1, step: 0.01 }),
    }, addon_actions_1.action('onChange'));
    var empty = React.createElement(Empty, { intersecting: intersecting });
    return (React.createElement(React.Fragment, null,
        empty,
        React.createElement("div", { ref: target },
            React.createElement(Text, { intersecting: intersecting })),
        empty));
};
var WithThreshold = function () {
    var target = React.useRef(null);
    var intersecting = __1.useIntersection(target, {
        threshold: 0.8,
    }, addon_actions_1.action('onChange'));
    var empty = React.createElement(Empty, { intersecting: intersecting });
    return (React.createElement(React.Fragment, null,
        empty,
        React.createElement("div", { ref: target },
            React.createElement(Text, { intersecting: intersecting })),
        empty));
};
var WithRoot = function () {
    var root = React.useRef(null);
    var target = React.useRef(null);
    var intersecting = __1.useIntersection(target, {
        root: root,
        rootMargin: '100px',
    }, addon_actions_1.action('onChange'));
    var empty = React.createElement(Empty, { intersecting: intersecting, height: "500px" });
    return (React.createElement("div", { ref: root, style: {
            overflow: 'hidden scroll',
            height: 300,
        } },
        empty,
        React.createElement("div", { ref: target },
            React.createElement(Text, { intersecting: intersecting })),
        empty));
};
react_1.storiesOf('useIntersection', module)
    .addDecorator(addon_knobs_1.withKnobs)
    .add('overview', function () { return React.createElement(Overview, null); })
    .add('with threshold (0.8)', function () { return React.createElement(WithThreshold, null); })
    .add('with root element and rootMargin (100px)', function () { return React.createElement(WithRoot, null); });
