"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var shallowequal_1 = tslib_1.__importDefault(require("shallowequal"));
exports.useIntersection = function (ref, options, callback) {
    if (options === void 0) { options = {}; }
    var defaultIntersecting = options.defaultIntersecting, opts = tslib_1.__rest(options, ["defaultIntersecting"]);
    var optsRef = react_1.useRef(opts);
    var _a = react_1.useState(defaultIntersecting === true), intersecting = _a[0], setIntersecting = _a[1];
    react_1.useEffect(function () {
        if (!shallowequal_1.default(optsRef.current, opts)) {
            optsRef.current = opts;
        }
    });
    react_1.useEffect(function () {
        if (ref.current == null) {
            return;
        }
        var observer = new IntersectionObserver(function (_a) {
            var entry = _a[0];
            setIntersecting(entry.isIntersecting);
            if (callback != null) {
                callback(entry);
            }
        }, tslib_1.__assign({}, optsRef.current, { root: optsRef.current.root != null ? optsRef.current.root.current : null }));
        observer.observe(ref.current);
        return function () {
            if (ref.current != null) {
                observer.unobserve(ref.current);
            }
        };
    }, [optsRef.current]);
    return intersecting;
};
